
from browser import document, window
from infection import HOSPITAL_CAPACITY


canvas = document['canvas']
ctx = canvas.getContext('2d')
ctx.font = "20px Arial"
# ctx.transform(1, 0, 0, -1, 0, canvas[0].height)  # <-- Not sure why this doesn't work like equivalent js...
legend = document['legend']
ctx2 = legend.getContext('2d')
ctx2.font = "14px Arial"


def draw_person(x, y, condition):
    if condition == 'healthy':
        ctx.fillStyle = '#05f'
    elif condition == 'asymptomatic':
        ctx.fillStyle = '#cc6'
    elif condition == 'sick':
        ctx.fillStyle = '#e83'
    elif condition == 'critical':
        ctx.fillStyle = '#d11'
    elif condition == 'recovered':
        ctx.fillStyle = '#2fb'
    else:  # 'dead'
        ctx.fillStyle = '#000'

    ctx.beginPath()
    ctx.arc(x, y, 5, 0, 6.28319)  # last arg is 2 * pi
    ctx.fill()

def draw_person_legend(x, y, condition):
    if condition == 'healthy':
        ctx2.fillStyle = '#05f'
    elif condition == 'asymptomatic':
        ctx2.fillStyle = '#cc6'
    elif condition == 'sick':
        ctx2.fillStyle = '#e83'
    elif condition == 'critical':
        ctx2.fillStyle = '#d11'
    elif condition == 'recovered':
        ctx2.fillStyle = '#2fb'
    else:  # 'dead'
        ctx2.fillStyle = '#000'

    ctx2.beginPath()
    ctx2.arc(x, y, 5, 0, 6.28319)  # last arg is 2 * pi
    ctx2.fill()

    ctx2.fillStyle = '#000'
    ctx2.fillText(condition.title(), x + 12, 20)


def draw_building(bldg_type):
    if bldg_type == 'school':
        ctx.strokeRect(100, 230, 100, 70)
        ctx.save()
        ctx.translate(0, 500)
        ctx.scale(1, -1)
        ctx.fillText(bldg_type.title(), 118, 242)
        ctx.restore()
    elif bldg_type == 'store':
        ctx.strokeRect(325, 230, 100, 70)
        ctx.save()
        ctx.translate(0, 500)
        ctx.scale(1, -1)
        ctx.fillText(bldg_type.title(), 350, 242)
        ctx.restore()
    elif bldg_type == 'work':
        ctx.strokeRect(550, 230, 100, 70)
        ctx.save()
        ctx.translate(0, 500)
        ctx.scale(1, -1)
        ctx.fillText(bldg_type.title(), 576, 242)
        ctx.restore()


def draw_buildings():
    ctx.fillStyle = '#000'
    draw_building('school')
    draw_building('store')
    draw_building('work')


def graph_sick_fraction(points):  # points is list[float, float]
    for day, sick_frac in points:
        if sick_frac < HOSPITAL_CAPACITY:
            ctx.fillStyle = '#000'
        else:
            ctx.fillStyle = '#f22'
        ctx.beginPath()
        ctx.arc(500 + 14 * day, 380 + sick_frac * 400, 3, 0, 6.28319)  # last arg is 2 * pi
        ctx.fill()
    ctx.fillStyle = '#222'
    for day, sick_frac in points:
        ctx.beginPath()
        ctx.arc(500 + 14 * day, 380, 1, 0, 6.28319)  # last arg is 2 * pi
        ctx.fill()


draw_buildings()

# draw legend
draw_person_legend(50, 15, 'healthy')
draw_person_legend(170, 15, 'asymptomatic')
draw_person_legend(335, 15, 'sick')
draw_person_legend(440, 15, 'critical')
draw_person_legend(565, 15, 'dead')
draw_person_legend(675, 15, 'recovered')